using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;

namespace GGC_HideTable
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			//GridEngineFactory.Factory = new GroupingEngineFactory();
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 24);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.Size = new System.Drawing.Size(576, 424);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.22";
			this.gridGroupingControl1.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridGroupingControl1_TableControlCellClick);
			this.gridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridGroupingControl1_QueryCellStyleInfo);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 486);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private int numberParentRows = 5;
		private int numberChildRows = 10;

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));
			dt.Columns.Add(new DataColumn("ID",typeof(int)));
			dt.Columns.Add("total",typeof(int));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dr[3] = i;
				dr[4] = 30 * i;
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			dt.Columns.Add("total",typeof(int));
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		DataSet ds;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();

			this.gridGroupingControl1.DataSource = parentTable;

			Console.WriteLine("ParentTable in the dataset is hidden in grid");

			GridSummaryColumnDescriptor sd1 = new GridSummaryColumnDescriptor("ID",SummaryType.Count,"ID","{Sum:####}"); 
			sd1.SummaryType = SummaryType.Int32Aggregate; 
			GridSummaryColumnDescriptor sd2 = new GridSummaryColumnDescriptor("total",SummaryType.Count,"total","{Sum:####}"); 
			sd2.SummaryType = SummaryType.Int32Aggregate; 
			//For showing two summary row
			this.gridGroupingControl1.TableDescriptor.SummaryRows.Add( new GridSummaryRowDescriptor("Row2", " Summary", new GridSummaryColumnDescriptor[] {sd1,sd2}));
			
			this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.Borders.All = new GridBorder(GridBorderStyle.None,Color.Blue );        
			this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.Borders.Bottom = new GridBorder(GridBorderStyle.Solid,Color.Blue);        
			this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.Borders.Top = new GridBorder(GridBorderStyle.Solid,Color.Blue);        
			this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.FloatCell = true;
			this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.FloodCell = true;
			this.gridGroupingControl1.TableDescriptor.Appearance.SummaryFieldCell.Borders.All = new GridBorder(GridBorderStyle.Solid,Color.Blue);        

			this.gridGroupingControl1.TableModel.QueryCoveredRange +=new GridQueryCoveredRangeEventHandler(TableModel_QueryCoveredRange);

			this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false; 

		}

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
	
		}

		private void gridGroupingControl1_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			
		}

		private void TableModel_QueryCoveredRange(object sender, GridQueryCoveredRangeEventArgs e)
		{
			GridTableModel model = sender as GridTableModel;
		
			Element el = model.Table.DisplayElements[e.RowIndex];
			if( el.Kind == DisplayElementKind.Summary )
			{
				GridSummaryRow row = el as GridSummaryRow;
				int index = row.SummaryRowDescriptor.SummaryColumns[0].ColInRecord;
				GridTableCellStyleInfo info =  model[e.RowIndex,e.ColIndex] as GridTableCellStyleInfo; 

				if( info.TableCellIdentity.TableCellType == GridTableCellType.SummaryTitleCell)
				{
					e.Range = GridRangeInfo.Cells(e.RowIndex,e.ColIndex ,e.RowIndex,e.ColIndex + index - 1);
					e.Handled = true;
				}
   
			}
		}
	}
}
